// DbObject.h : Declaration of the CDbObject

#pragma once
#include "resource.h"       // main symbols


// IDbObject
[
	object,
	uuid("72FE835B-9DDF-4159-BBB7-F5700F0A0E57"),
	dual,	helpstring("IDbObject Interface"),
	pointer_default(unique)
]
__interface IDbObject : IDispatch
{
	[id(1), helpstring("method UpdateIndexes")] HRESULT UpdateIndexes(void);
};


// _IDbObjectEvents
[
	dispinterface,
	uuid("4E5C8AEC-0F6B-46A1-9451-FF8E3168AAA0"),
	helpstring("_IDbObjectEvents Interface")
]
__interface _IDbObjectEvents
{
	[id(1), helpstring("method FinishedUpdating")] HRESULT FinishedUpdating(void);
};


// CDbObject

[
	coclass,
	threading("apartment"),
	event_source("com"),
	vi_progid("DbServerAttEvent.DbObject"),
	progid("DbServerAttEvent.DbObject.1"),
	version(1.0),
	uuid("CB3F3AC4-DB2A-44C2-A2CC-8C024EA75617"),
	helpstring("DbObject Class")
]
class ATL_NO_VTABLE CDbObject : 
	public IDbObject
{
public:
	CDbObject()
	{
	}

	__event __interface _IDbObjectEvents;

	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}
	
	void FinalRelease() 
	{
	}

public:

	STDMETHOD(UpdateIndexes)(void);
};

